//+------------------------------------------------------------------+
//|                                           TrendStrength_v2.mq4 |
//|                           Copyright  2007, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers   3
#property indicator_color1    Yellow
#property indicator_style1    STYLE_DASH
#property indicator_color2    LimeGreen
#property indicator_width2    2 
#property indicator_color3    Red
#property indicator_width3    2 

//---- input parameters
extern int     Len         =    50; // Period of evaluation
extern int     Smooth      =     5; // Period of smoothing
extern double  K           = 4.236; // Multiplier 
 
//---- buffers
double SmRSX[];
double UpTrend[];
double DnTrend[];
double RSX[];
double ATRRSX[];
double smin[];
double smax[];
double trend[];
double myPoint;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   myPoint = SetPoint(Symbol()); 
   IndicatorBuffers(8);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(0,SmRSX);
   SetIndexBuffer(1,UpTrend);
   SetIndexBuffer(2,DnTrend);
   SetIndexBuffer(3,RSX);
   SetIndexBuffer(4,ATRRSX);
   SetIndexBuffer(5,smin);
   SetIndexBuffer(6,smax);
   SetIndexBuffer(7,trend);
//---- name for DataWindow and indicator subwindow label
   string short_name="TurboTrendStrength("+Len+","+Smooth+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Smoothed RSX");
   SetIndexLabel(1,"UpTrend");
   SetIndexLabel(2,"DnTrend");    
//----
   SetIndexDrawBegin(0,3*Len+Smooth);
   SetIndexDrawBegin(1,3*Len+Smooth);
   SetIndexDrawBegin(2,3*Len+Smooth);
   
   return(0);
}
double SetPoint(string mySymbol)
  {
   double mPoint, myDigits;
   
   myDigits = MarketInfo (mySymbol, MODE_DIGITS);
   if (myDigits < 4)
      mPoint = 0.01;
   else
      mPoint = 0.0001;
   if (myDigits > 4)
      mPoint = 0.00001;
   else
      mPoint = 0.0001;
   
   return(mPoint);
 }   

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int      shift, limit,counted_bars=IndicatorCounted();
//---- 
   if (Bars-1<3*Len+Smooth+1)return(0);
   if (counted_bars<0)return(-1);
   if (counted_bars>0) counted_bars--;
   
   limit=Bars-counted_bars-1; 
   
   
   for( shift=limit; shift>=0; shift--)
   RSX[shift] = iCustom(NULL,0,"Turbo JRSX",Len,0,shift);
       
   for( shift=limit; shift>=0; shift--)
   {
   SmRSX[shift]=iMAOnArray(RSX,0,Smooth,0,1,shift);     
   
      if(SmRSX[shift] > SmRSX[shift+1]) {double hRSX = SmRSX[shift]; double lRSX = SmRSX[shift+1];}
      else 
      if(SmRSX[shift] < SmRSX[shift+1]) {hRSX = SmRSX[shift+1]; lRSX = SmRSX[shift];}
      else
      {hRSX = SmRSX[shift]; lRSX = SmRSX[shift];}
   
   ATRRSX[shift] = hRSX - lRSX;
   }
                
   for( shift=limit; shift>=0; shift--)
   {
   double Delta = iMAOnArray(ATRRSX,0,27,0,1,shift);  
   
   smin[shift] = SmRSX[shift] - K*Delta; 
   smax[shift] = SmRSX[shift] + K*Delta;
      
   trend[shift] = trend[shift+1];
   
   if (SmRSX[shift]>smax[shift+1])  trend[shift]= 1; 
	if (SmRSX[shift]<smin[shift+1])  trend[shift]=-1;

      if(trend[shift]>0)
	   {
	   if (smin[shift]<smin[shift+1]) smin[shift]=smin[shift+1];
	   UpTrend[shift]=smin[shift];
	   DnTrend[shift]=EMPTY_VALUE;
	   }
	   else
	   if(trend[shift]<0)
	   {
	   if(smax[shift]>smax[shift+1]) smax[shift]=smax[shift+1];
	   DnTrend[shift]=smax[shift];
	   UpTrend[shift]=EMPTY_VALUE;
	   }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+